.\"	$NetBSD: passwd.5,v 1.27 2007/06/21 15:12:59 ginsbach Exp $
.\"
.\" Copyright (c) 1988, 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\" Portions Copyright (c) 1994, Jason Downs.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR(S) ``AS IS'' AND ANY EXPRESS
.\" OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
.\" WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
.\" DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR(S) BE LIABLE FOR ANY DIRECT,
.\" INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
.\" (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
.\" SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
.\" CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     @(#)passwd.5	8.1 (Berkeley) 6/5/93
.\"
.Dd June 21, 2007
.Dt PASSWD 5
.Os
.Sh NAME
.Nm passwd ,
.Nm master.passwd
.Nd format of the password file
.Sh DESCRIPTION
The
.Nm passwd
files are the local source of password information.
They can be used in conjunction with the Hesiod domain
.Sq passwd
and the
.Tn NIS
maps
.Sq passwd.byname ,
.Sq passwd.byuid ,
.Sq master.passwd.byname ,
and
.Sq master.passwd.byuid ,
as controlled by
.Xr nsswitch.conf 5 .
.Pp
The
.Nm master.passwd
file is readable only by root, and consists of newline separated
.Tn ASCII
records, one per user, containing ten colon
.Pq Dq \&:
separated fields.
.Pp
Each line has the form:
.Dl name:password:uid:gid:class:change:expire:gecos:home_dir:shell
.Pp
These fields are as follows:
.Bl -tag -width password -offset indent -compact
.It Em name
User's login name.
.It Em password
User's
.Em encrypted
password.
.It Em uid
User's id.
.It Em gid
User's login group id.
.It Em class
User's login class.
.It Em change
Password change time.
.It Em expire
Account expiration time.
.It Em gecos
General information about the user.
.It Em home_dir
User's home directory.
.It Em shell
User's login shell.
.El
.Pp
Be aware that each line is limited to 1024 characters; longer ones will be
ignored.
This limit can be queried through
.Xr sysconf 3
by using the
.Li _SC_GETPW_R_SIZE_MAX
parameter.
.Pp
The
.Nm
file is generated from the
.Nm master.passwd
file by
.Xr pwd_mkdb 8 ,
has the
.Em class ,
.Em change ,
and
.Em expire
fields removed, and the
.Em password
field replaced by a
.Dq \&* .
.Pp
The
.Em name
field is the login used to access the computer account, and the
.Em uid
field is the number associated with it.
They should both be unique across the system (and often across a
group of systems) since they control file access.
.Pp
While it is possible to have multiple entries with identical login names
and/or identical user id's, it is usually a mistake to do so.
Routines that manipulate these files will often return only one of
the multiple entries, and that one by random selection.
.Pp
The login name must never begin with a hyphen
.Pq Dq \&- ;
also, it is strongly suggested that neither upper-case characters nor dots
.Pq Dq \&.
be part of the name, as this tends to confuse mailers.
No field may contain a colon
.Pq Dq \&:
as this has been used historically to separate the fields in the user database.
.Pp
The
.Em password
field is the
.Em encrypted
form of the password.
If the
.Em password
field is empty, no password will be required to gain access to the
machine.
This is almost invariably a mistake.
Because these files contain the encrypted user passwords, they should
not be readable by anyone without appropriate privileges.
For the possible ciphers used in this field see
.Xr passwd.conf 5 .
.Pp
The
.Em gid
field is the group that the user will be placed in upon login.
Since this system supports multiple groups (see
.Xr groups 1 )
this field currently has little special meaning.
.Pp
The
.Em class
field is a key for a user's login class.
Login classes are defined in
.Xr login.conf 5 ,
which is a
.Xr termcap 5
style database of user attributes, accounting, resource and
environment settings.
.Pp
The
.Em change
field is the number of seconds from the epoch,
.Dv UTC ,
until the
password for the account must be changed.
This field may be left empty to turn off the password aging feature.
If this is set to
.Dq -1
then the user will be prompted to change their password at the next
login.
.Pp
The
.Em expire
field is the number of seconds from the epoch,
.Dv UTC ,
until the
account expires.
This field may be left empty to turn off the account aging feature.
.Pp
If either of the
.Em change
or
.Em expire
fields are set, the system will remind the user of the impending
change or expiry if they login within a configurable period
(defaulting to 14 days) before the event.
.Pp
The
.Em gecos
field normally contains comma
.Pq Dq \&,
separated subfields as follows:
.Pp
.Bl -tag -width office -offset indent -compact
.It Em name
user's full name
.It Em office
user's office number
.It Em wphone
user's work phone number
.It Em hphone
user's home phone number
.El
.Pp
The full name may contain an ampersand
.Pq Dq \&\*[Am]
which will be replaced by
the capitalized login name when the gecos field is displayed or used
by various programs such as
.Xr finger 1 ,
.Xr sendmail 8 ,
etc.
.Pp
The office and phone number subfields are used by the
.Xr finger 1
program, and possibly other applications.
.Pp
The user's home directory is the full
.Ux
path name where the user
will be placed on login.
.Pp
The shell field is the command interpreter the user prefers.
If there is nothing in the
.Em shell
field, the Bourne shell
.Pq Pa /bin/sh
is assumed.
.Sh HESIOD SUPPORT
If
.Sq dns
is specified for the
.Sq passwd
database in
.Xr nsswitch.conf 5 ,
then
.Nm
lookups occur from the
.Sq passwd
Hesiod domain.
.Sh NIS SUPPORT
If
.Sq nis
is specified for the
.Sq passwd
database in
.Xr nsswitch.conf 5 ,
then
.Nm
lookups occur from the
.Sq passwd.byname ,
.Sq passwd.byuid ,
.Sq master.passwd.byname ,
and
.Sq master.passwd.byuid
.Tn NIS
maps.
.Sh COMPAT SUPPORT
If
.Sq compat
is specified for the
.Sq passwd
database, and either
.Sq dns
or
.Sq nis
is specified for the
.Sq passwd_compat
database in
.Xr nsswitch.conf 5 ,
then the
.Nm
file also supports standard
.Sq +/-
exclusions and inclusions, based on user names and netgroups.
.Pp
Lines beginning with a minus sign
.Pq Dq \&-
are entries marked as being excluded from any following inclusions,
which are marked with a plus sign
.Pq Dq \&+ .
.Pp
If the second character of the line is an at sign
.Pq Dq \&@ ,
the operation
involves the user fields of all entries in the netgroup specified by the
remaining characters of the
.Em name
field.
Otherwise, the remainder of the
.Em name
field is assumed to be a specific user name.
.Pp
The
.Dq \&+
token may also be alone in the
.Em name
field, which causes all users from either the Hesiod domain
.Nm
(with
.Sq passwd_compat: dns )
or
.Sq passwd.byname
and
.Sq passwd.byuid
.Tn NIS
maps (with
.Sq passwd_compat: nis )
to be included.
.Pp
If the entry contains non-empty
.Em uid
or
.Em gid
fields, the specified numbers will override the information retrieved
from the Hesiod domain or the
.Tn NIS
maps.
As well, if the
.Em gecos ,
.Em home_dir
or
.Em shell
entries contain text, it will override the information included via
Hesiod or
.Tn NIS .
On some systems, the
.Em passwd
field may also be overridden.
.Sh SEE ALSO
.Xr chpass 1 ,
.Xr login 1 ,
.Xr newgrp 1 ,
.Xr passwd 1 ,
.Xr pwhash 1 ,
.Xr getpwent 3 ,
.Xr login_getclass 3 ,
.Xr login.conf 5 ,
.Xr netgroup 5 ,
.Xr passwd.conf 5 ,
.Xr adduser 8 ,
.Xr pwd_mkdb 8 ,
.Xr vipw 8 ,
.Xr yp 8
.Pp
.%T "Managing NFS and NIS"
(O'Reilly \*[Am] Associates)
.Sh COMPATIBILITY
The password file format has changed since
.Bx 4.3 .
The following awk script can be used to convert your old-style password
file into a new style password file.
The additional fields
.Dq class ,
.Dq change
and
.Dq expire
are added, but are turned off by default.
To set them,
use the current day in seconds from the epoch + whatever number of seconds
of offset you want.
.Bd -literal -offset indent
BEGIN { FS = ":"}
{ print $1 ":" $2 ":" $3 ":" $4 "::0:0:" $5 ":" $6 ":" $7 }
.Ed
.Sh HISTORY
A
.Nm
file format appeared in
.At v6 .
.Pp
The
.Tn NIS
.Nm
file format first appeared in SunOS.
.Pp
The Hesiod support first appeared in
.Nx 1.4 .
.Pp
The
.Xr login.conf 5
capability first appeared in
.Nx 1.5 .
.Sh BUGS
User information should (and eventually will) be stored elsewhere.
.Pp
Placing
.Sq compat
exclusions in the file after any inclusions will have
unexpected results.
